package com.liang.dao;

import com.liang.entity.BaseFoundation;
import com.liang.entity.BaseMost;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (BaseMost)表数据库访问层
 *
 * @author makejava
 * @since 2023-03-04 11:25:23
 */
public interface BaseMostDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    BaseMost queryById(String id);

    /**
     * 查询指定行数据
     *
     * @param baseMost 查询条件
     * @param pageable 分页对象
     * @return 对象列表
     */
    List<BaseMost> queryAllByLimit(BaseMost baseMost, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param baseMost 查询条件
     * @return 总行数
     */
    long count(BaseMost baseMost);

    /**
     * 新增数据
     *
     * @param baseMost 实例对象
     * @return 影响行数
     */
    int insert(BaseMost baseMost);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<BaseMost> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<BaseMost> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<BaseMost> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<BaseMost> entities);

    /**
     * 修改数据
     *
     * @param baseMost 实例对象
     * @return 影响行数
     */
    int update(BaseMost baseMost);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(String id);

    /**
     * 获取所有数据
     *
     * @return
     */
    List<BaseMost> queryAll();
}

